import acm.graphics.*;
import acm.program.GraphicsProgram;
import acm.util.RandomGenerator;
import java.lang.System.*;
import java.io.*;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
public class Game extends GraphicsProgram{
	public static void main(String[] args){
		new Game().start(args);
	}
	boolean wdown = false;
	boolean sdown = false;
	boolean adown = false;
	boolean ddown = false;
	boolean wwdown = false;
	boolean ssdown = false;
	boolean aadown = false;
	boolean dddown = false;
	boolean canmove = false;
	boolean title = true;
	boolean easyPressed = false;
	boolean normalPressed = false;
	boolean hardPressed = false;
	boolean titlePressed = false;
	int occildir = 0;
	double stx;
	double sty;
	int exx;
	int exy;
	int mousex;
	int mousey;
	int texcon;
	int Deaths = 0;
	int blockSize = 32;
	int level = 1;
	int xs = 704;
	int ys = 304;
	int difficulty = 100;
	private ArrayList<GRect> Walls = new ArrayList<GRect>();
	private ArrayList<GRect> Blocks = new ArrayList<GRect>();
	private ArrayList<String> Lines = new ArrayList<String>();
	private ArrayList<GRect> Spikes = new ArrayList<GRect>();
	private ArrayList<GRect> Stops = new ArrayList<GRect>();
	private ArrayList<GRect> Ups = new ArrayList<GRect>();
	private ArrayList<GRect> Downs = new ArrayList<GRect>();
	private ArrayList<GRect> Lefts = new ArrayList<GRect>();
	private ArrayList<GRect> Rights = new ArrayList<GRect>();
	private ArrayList<GRect> Checks = new ArrayList<GRect>();
	private ArrayList<GRect> Checkstops = new ArrayList<GRect>();
	private ArrayList<GImage> CheckLights = new ArrayList<GImage>();
	private ArrayList<GImage> StopLights = new ArrayList<GImage>();
	private ArrayList<GImage> Occilators = new ArrayList<GImage>();
	public void run(){
		addKeyListeners();
		addMouseListeners();
		GImage Title = new GImage("Title Screen.png",0,0);
		add(Title);
		GImage DifficultySelect = new GImage("Diff_Normal.png",123,183);
		add(DifficultySelect);
		setSize(720,360);
		while(title){
			if(easyPressed){
				DifficultySelect.setImage("Diff_Easy.png");
				difficulty = 150;
			}
			if(normalPressed){
				DifficultySelect.setImage("Diff_Normal.png");
				difficulty = 100;
			}
			if(hardPressed){
				DifficultySelect.setImage("Diff_Hard.png");
				difficulty = 75;
			}
			if(titlePressed){
				title = false;
			}
		}
		try{
			FileReader fw = new FileReader("Levels/Level_" + level + ".txt");
			BufferedReader pw = new BufferedReader(fw);
			String LevelName = pw.readLine();
			blockSize = Integer.parseInt(pw.readLine());
			int StageWidth = Integer.parseInt(pw.readLine());
			int StageHeight = Integer.parseInt(pw.readLine());
			String lineOfLevel;
			char blockValueItTo;
			for(int Y = 0;Y < StageHeight;Y++){
				lineOfLevel = pw.readLine();
				Lines.add(lineOfLevel);
				System.out.println(lineOfLevel);
			}
			for(int Y = 0;Y < StageHeight;Y++){
				for(int X = 0;X < StageWidth;X++){
					GRect block = new GRect(X * blockSize,Y * blockSize,blockSize,blockSize);
					GImage Over = new GImage("Tiles/8/0.png",X * blockSize,Y * blockSize);
					blockValueItTo = Lines.get(Y).charAt(X);
					if(blockValueItTo == '0'){
						block.setColor(Color.white);
						block.setFilled(true);
						add(block);
						if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
							Over.setImage("Tiles/" + blockSize + "/0.png");
							add(Over);
						}
					}else{
						if(blockValueItTo == '1'){
							block.setColor(Color.black);
							Walls.add(block);
							block.setFilled(true);
							add(block);
							texcon = 0;
							//Over = new GImage("Tiles/" + blockSize + "/Center.png",X * blockSize + blockSize / 4,Y * blockSize + blockSize / 4);
							//add(Over);
							//Over = new GImage("Tiles/" + blockSize + "/Corner_0.png",X * blockSize + blockSize * 3 / 4,Y * blockSize);
							//add(Over);
							//Over = new GImage("Tiles/" + blockSize + "/Corner_1.png",X * blockSize,Y * blockSize);
							//add(Over);
							//Over = new GImage("Tiles/" + blockSize + "/Corner_0.png",X * blockSize,Y * blockSize + blockSize * 3 / 4);
							//add(Over);
							//Over = new GImage("Tiles/" + blockSize + "/Corner_1.png",X * blockSize + blockSize * 3 / 4,Y * blockSize + blockSize * 3 / 4);
							//add(Over);
							if(Y == 0){
								texcon = 8;
								//Over = new GImage("Tiles/" + blockSize + "/Edge_11.png",X * blockSize + blockSize / 4,Y * blockSize);
								//add(Over);
							}else{
								if(Lines.get(Y - 1).charAt(X) == '1'){
									texcon = 8;
									//Over = new GImage("Tiles/" + blockSize + "/Edge_11.png",X * blockSize + blockSize / 4,Y * blockSize);
									//add(Over);
								}else{
									//Over = new GImage("Tiles/" + blockSize + "/Edge_3.png",X * blockSize + blockSize / 4,Y * blockSize);
									//add(Over);
								}
							}
							if(X == 0){
								texcon = texcon + 4;
								//Over = new GImage("Tiles/" + blockSize + "/Edge_10.png",X * blockSize,Y * blockSize + blockSize / 4);
								//add(Over);
							}else{
								if(Lines.get(Y).charAt(X - 1) == '1'){
									texcon = texcon + 4;
									//Over = new GImage("Tiles/" + blockSize + "/Edge_10.png",X * blockSize,Y * blockSize + blockSize / 4);
									//add(Over);
								}else{
									//Over = new GImage("Tiles/" + blockSize + "/Edge_2.png",X * blockSize,Y * blockSize + blockSize / 4);
									//add(Over);
								}
							}
							if(Y == StageHeight - 1){
								texcon = texcon + 2;
								//Over = new GImage("Tiles/" + blockSize + "/Edge_9.png",X * blockSize + blockSize / 4,Y * blockSize + blockSize * 3 / 4);
								//add(Over);
							}else{
								if(Lines.get(Y + 1).charAt(X) == '1'){
									texcon = texcon + 2;
									//Over = new GImage("Tiles/" + blockSize + "/Edge_9.png",X * blockSize + blockSize / 4,Y * blockSize + blockSize * 3 / 4);
									//add(Over);
								}else{
									//Over = new GImage("Tiles/" + blockSize + "/Edge_1.png",X * blockSize + blockSize / 4,Y * blockSize + blockSize * 3 / 4);
									//add(Over);
								}
							}
							if(X == StageWidth - 1){
								texcon = texcon + 1;
								//Over = new GImage("Tiles/" + blockSize + "/Edge_8.png",X * blockSize + blockSize * 3 / 4,Y * blockSize + blockSize / 4);
								//add(Over);
							}else{
								if(Lines.get(Y).charAt(X + 1) == '1'){
									texcon = texcon + 1;
									//Over = new GImage("Tiles/" + blockSize + "/Edge_8.png",X * blockSize + blockSize * 3 / 4,Y * blockSize + blockSize / 4);
									//add(Over);
								}else{
									//Over = new GImage("Tiles/" + blockSize + "/Edge_0.png",X * blockSize + blockSize * 3 / 4,Y * blockSize + blockSize / 4);
									//add(Over);
								}
							}
							if(texcon == 15){
								if(Y != 0){
									if(X != StageWidth - 1){
										if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
											texcon = 16;
										}
									}
								}
								if(Y != StageHeight - 1){
									if(X != StageWidth - 1){
										if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
											texcon = 17;
											if(Y != 0){
												if(X != StageWidth - 1){
													if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
														texcon = 21;
													}
												}
											}
										}
									}
								}
								if(Y != StageHeight - 1){
									if(X != 0){
										if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
											texcon = 18;
											if(Y != 0){
												if(X != StageWidth - 1){
													if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
														texcon = 24;
													}
												}
											}
											if(Y != StageHeight - 1){
												if(X != StageWidth - 1){
													if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
														texcon = 22;
														if(Y != 0){
															if(X != StageWidth - 1){
																if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
																	texcon = 27;
																}
															}
														}
													}
												}
											}
										}
									}
								}
								if(Y != 0){
									if(X != 0){
										if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
											texcon = 19;
											if(Y != StageHeight - 1){
												if(X != 0){
													if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
														texcon = 23;
													}
												}
											}
											if(Y != StageHeight - 1){
												if(X != StageWidth - 1){
													if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
														texcon = 25;
														if(Y != StageHeight - 1){
															if(X != 0){
																if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
																	texcon = 28;
																}
															}
														}
													}
												}
											}
											if(Y != 0){
												if(X != StageWidth - 1){
													if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
														texcon = 20;
														if(Y != StageHeight - 1){
															if(Y != StageHeight - 1){
																if(X != 0){
																	if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
																		texcon = 29;
																	}
																}
															}
															if(X != StageWidth - 1){
																if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
																	texcon = 26;
																	if(Y != StageHeight - 1){
																		if(X != 0){
																			if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
																				texcon = 30;
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
							if(texcon == 14){
								if(Y != 0){
									if(X != 0){
										if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
											texcon = 34;
										}
									}
								}
								if(Y != StageHeight - 1){
									if(X != 0){
										if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
											texcon = 38;
											if(Y != 0){
												if(X != 0){
													if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
														texcon = 42;
													}
												}
											}
										}
									}
								}
							}
							if(texcon == 13){
								if(Y != 0){
									if(X != StageWidth - 1){
										if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
											texcon = 31;
										}
									}
								}
								if(Y != 0){
									if(X != 0){
										if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
											texcon = 35;
											if(Y != 0){
												if(X != StageWidth - 1){
													if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
														texcon = 39;
													}
												}
											}
										}
									}
								}
							}
							if(texcon == 13){
								if(Y != 0){
									if(X != StageWidth - 1){
										if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
											texcon = 31;
										}
									}
								}
								if(Y != 0){
									if(X != 0){
										if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
											texcon = 35;
											if(Y != 0){
												if(X != StageWidth - 1){
													if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
														texcon = 39;
													}
												}
											}
										}
									}
								}
							}
							if(texcon == 11){
								if(Y != StageHeight - 1){
									if(X != StageWidth - 1){
										if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
											texcon = 32;
										}
									}
								}
								if(Y != 0){
									if(X != StageWidth - 1){
										if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
											texcon = 36;
											if(Y != StageHeight - 1){
												if(X != StageWidth - 1){
													if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
														texcon = 40;
													}
												}
											}
										}
									}
								}
							}
							if(texcon == 7){
								if(Y != StageHeight - 1){
									if(X != 0){
										if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
											texcon = 33;
										}
									}
								}
								if(Y != StageHeight - 1){
									if(X != StageWidth - 1){
										if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
											texcon = 37;
											if(Y != StageHeight - 1){
												if(X != 0){
													if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
														texcon = 41;
													}
												}
											}
										}
									}
								}
							}
							if(texcon == 3){
								if(Y != StageHeight - 1){
									if(X != StageWidth - 1){
										if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
											texcon = 43;
										}
									}
								}
							}
							if(texcon == 6){
								if(Y != StageHeight - 1){
									if(X != 0){
										if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
											texcon = 44;
										}
									}
								}
							}
							if(texcon == 12){
								if(Y != 0){
									if(X != 0){
										if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
											texcon = 45;
										}
									}
								}
							}
							if(texcon == 9){
								if(Y != 0){
									if(X != StageWidth - 1){
										if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
											texcon = 46;
										}
									}
								}
							}
							if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
								Over.setImage("Tiles/" + blockSize + "/1_" + texcon + ".png");
								add(Over);
							}
						}else{
							if(blockValueItTo == '2'){
								block.setColor(Color.blue);
								stx = X * blockSize;
								sty = Y * blockSize;
								block.setFilled(true);
								add(block);
								if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
									Over.setImage("Tiles/" + blockSize + "/2_0.png");
									add(Over);
								}
							}else{
								if(blockValueItTo == 'a'){
									block.setColor(Color.yellow);
									Spikes.add(block);
									block.setFilled(true);
									add(block);
									texcon = 0;
									if(Y == 0){
										texcon = 8;
									}else{
										if(Lines.get(Y - 1).charAt(X) == 'a'){
											texcon = 8;
										}
									}
									if(X == 0){
										texcon = texcon + 4;
									}else{
										if(Lines.get(Y).charAt(X - 1) == 'a'){
											texcon = texcon + 4;
										}
									}
									if(Y == StageHeight - 1){
										texcon = texcon + 2;
									}else{
										if(Lines.get(Y + 1).charAt(X) == 'a'){
											texcon = texcon + 2;
										}
									}
									if(X == StageWidth - 1){
										texcon = texcon + 1;
									}else{
										if(Lines.get(Y).charAt(X + 1) == 'a'){
											texcon = texcon + 1;
										}
									}
									if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
										Over.setImage("Tiles/" + blockSize + "/a_" + texcon + ".png");
										add(Over);
									}
								}else{
									if(blockValueItTo == 'b'){
										block.setColor(Color.gray);
										Stops.add(block);
										block.setFilled(true);
										add(block);
										texcon = 0;
										if(Y == 0){
											texcon = 8;
										}else{
											if(Lines.get(Y - 1).charAt(X) == 'b'){
												texcon = 8;
											}
										}
										if(X == 0){
											texcon = texcon + 4;
										}else{
											if(Lines.get(Y).charAt(X - 1) == 'b'){
												texcon = texcon + 4;
											}
										}
										if(Y == StageHeight - 1){
											texcon = texcon + 2;
										}else{
											if(Lines.get(Y + 1).charAt(X) == 'b'){
												texcon = texcon + 2;
											}
										}
										if(X == StageWidth - 1){
											texcon = texcon + 1;
										}else{
											if(Lines.get(Y).charAt(X + 1) == 'b'){
												texcon = texcon + 1;
											}
										}
										if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
											Over.setImage("Tiles/" + blockSize + "/b_" + texcon + ".png");
											add(Over);
										}
									}else{
										if(blockValueItTo == '3'){
											block.setColor(Color.red);
											exx = X * blockSize;
											exy = Y * blockSize;
											block.setFilled(true);
											add(block);
											if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
												Over.setImage("Tiles/" + blockSize + "/3_0.png");
												add(Over);
											}
										}else{
											if(blockValueItTo == 'c'){
												block.setColor(Color.cyan);
												Ups.add(block);
												block.setFilled(true);
												add(block);
											}else{
												if(blockValueItTo == 'd'){
													block.setColor(Color.pink);
													Downs.add(block);
													block.setFilled(true);
													add(block);
												}else{
													if(blockValueItTo == 'e'){
														block.setColor(Color.orange);
														Rights.add(block);
														block.setFilled(true);
														add(block);
													}else{
														if(blockValueItTo == 'f'){
															block.setColor(Color.magenta);
															Lefts.add(block);
															block.setFilled(true);
															add(block);
														}else{
															if(blockValueItTo == '5'){
																block.setColor(Color.green);
																Checkstops.add(block);
																block.setFilled(true);
																add(block);
																Stops.add(block);
																block.setColor(Color.gray);
																block.setFilled(true);
																add(block);
																texcon = 0;
																if(Y == 0){
																	texcon = 8;
																}else{
																	if(Lines.get(Y - 1).charAt(X) == 'b' || Lines.get(Y - 1).charAt(X) == '5'){
																		texcon = 8;
																	}
																}
																if(X == 0){
																	texcon = texcon + 4;
																}else{
																	if(Lines.get(Y).charAt(X - 1) == 'b' || Lines.get(Y).charAt(X - 1) == '5'){
																		texcon = texcon + 4;
																	}
																}
																if(Y == StageHeight - 1){
																	texcon = texcon + 2;
																}else{
																	if(Lines.get(Y + 1).charAt(X) == 'b' || Lines.get(Y + 1).charAt(X) == '5'){
																		texcon = texcon + 2;
																	}
																}
																if(X == StageWidth - 1){
																	texcon = texcon + 1;
																}else{
																	if(Lines.get(Y).charAt(X + 1) == 'b' || Lines.get(Y).charAt(X + 1) == '5'){
																		texcon = texcon + 1;
																	}
																}
																if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																	Over.setImage("Tiles/" + blockSize + "/b_" + texcon + ".png");
																	add(Over);
																}
																Over = new GImage("Tiles/8/0.png",X * blockSize,Y * blockSize);
																if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																	Over.setImage("Tiles/" + blockSize + "/5_0.png");
																	add(Over);
																	StopLights.add(Over);
																}
															}else{
																block.setColor(Color.green);
																block.setFilled(true);
																add(block);
																if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																	Over.setImage("Tiles/" + blockSize + "/e.png");
																	add(Over);
																	Occilators.add(Over);
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
					Blocks.add(block);
				}
			}
			setSize(blockSize * StageWidth + 17,blockSize * StageHeight + 59);
			pw.close();
			GImage Char = new GImage("Tiles/20/Kitty.png",stx,sty);
			if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
				Char.setImage("Tiles/" + blockSize + "/Kitty.png");
			}
			add(Char);
			GLabel LevelLabel = new GLabel("Level: " + level + " " + LevelName);
			LevelLabel.setLocation(0,11);
			add(LevelLabel);
			GLabel DeathCounter = new GLabel("Deaths: " + Deaths);
			DeathCounter.setLocation(blockSize * StageWidth - 64,11);
			add(DeathCounter);
			while(true){
				pause(difficulty);
				if(occildir == 7){
					occildir = 0;
				}else{
					occildir = occildir + 1;
				}
				for(int i = 0; i < Ups.size(); i++){
					GRect L = Ups.get(i);
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						wdown = true;
					}
				}
				if(wwdown){
					wdown = true;
					sdown = false;
					adown = false;
					ddown = false;
					wwdown = false;
				}
				if(wdown){
					canmove = true;
					for(int i = 0; i < Walls.size(); i++){
						GRect L = Walls.get(i);
						if(L.getX() == Char.getX() && L.getY() == Char.getY() - blockSize){
							canmove = false;
						}
					}
					if(canmove){
						Char.setLocation(Char.getX(),Char.getY() - blockSize);
					}
					sdown = false;
					adown = false;
					ddown = false;
					for(int i = 0; i < Stops.size(); i++){
						GRect L = Stops.get(i);
						if(L.getX() == Char.getX() && L.getY() == Char.getY()){
							wdown = false;
						}
					}
				}
				for(int i = 0; i < Downs.size(); i++){
					GRect L = Downs.get(i);
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						sdown = true;
					}
				}
				if(ssdown){
					sdown = true;
					wdown = false;
					adown = false;
					ddown = false;
					ssdown = false;
				}
				if(sdown){
					canmove = true;
					for(int i = 0; i < Walls.size(); i++){
						GRect L = Walls.get(i);
						if(L.getX() == Char.getX() && L.getY() == Char.getY() + blockSize){
							canmove = false;
						}
					}
					if(canmove){
						Char.setLocation(Char.getX(),Char.getY() + blockSize);
					}
					wdown = false;
					adown = false;
					ddown = false;
					for(int i = 0; i < Stops.size(); i++){
						GRect L = Stops.get(i);
						if(L.getX() == Char.getX() && L.getY() == Char.getY()){
							sdown = false;
						}
					}
				}
				for(int i = 0; i < Lefts.size(); i++){
					GRect L = Lefts.get(i);
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						adown = true;
					}
				}
				for(int i = 0; i < Occilators.size(); i++){
					GImage L = Occilators.get(i);
					if(occildir < 4){
						L.setImage("Tiles/" + blockSize + "/e.png");
					}else{
						L.setImage("Tiles/" + blockSize + "/f.png");
					}
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						if(occildir < 4){
							ddown = true;
							adown = false;
						}else{
							adown = true;
							ddown = false;
						}
					}
				}
				if(aadown){
					adown = true;
					wdown = false;
					sdown = false;
					ddown = false;
					aadown = false;
				}
				if(adown){
					canmove = true;
					for(int i = 0; i < Walls.size(); i++){
						GRect L = Walls.get(i);
						if(L.getX() == Char.getX() - blockSize && L.getY() == Char.getY()){
							canmove = false;
						}
					}
					if(canmove){
						Char.setLocation(Char.getX() - blockSize,Char.getY());
					}
					wdown = false;
					sdown = false;
					ddown = false;
					for(int i = 0; i < Stops.size(); i++){
						GRect L = Stops.get(i);
						if(L.getX() == Char.getX() && L.getY() == Char.getY()){
							adown = false;
						}
					}
				}
				for(int i = 0; i < Occilators.size(); i++){
					GImage L = Occilators.get(i);
					if(occildir < 4){
						L.setImage("Tiles/" + blockSize + "/e.png");
					}else{
						L.setImage("Tiles/" + blockSize + "/f.png");
					}
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						if(occildir < 4){
							ddown = true;
							adown = false;
						}else{
							adown = true;
							ddown = false;
						}
					}
				}
				for(int i = 0; i < Rights.size(); i++){
					GRect L = Rights.get(i);
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						ddown = true;
					}
				}
				if(dddown){
					ddown = true;
					wdown = false;
					sdown = false;
					adown = false;
					dddown = false;
				}
				if(ddown){
					canmove = true;
					for(int i = 0; i < Walls.size(); i++){
						GRect L = Walls.get(i);
						if(L.getX() == Char.getX() + blockSize && L.getY() == Char.getY()){
							canmove = false;
						}
					}
					if(canmove){
						Char.setLocation(Char.getX() + blockSize,Char.getY());
					}
					wdown = false;
					sdown = false;
					adown = false;
					for(int i = 0; i < Stops.size(); i++){
						GRect L = Stops.get(i);
						if(L.getX() == Char.getX() && L.getY() == Char.getY()){
							ddown = false;
						}
					}
				}
				for(int i = 0; i < Spikes.size(); i++){
					GRect L = Spikes.get(i);
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						remove(Char);
						Char = new GImage("Tiles/20/Kitty.png",stx,sty);
						if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
							Char.setImage("Tiles/" + blockSize + "/Kitty.png");
						}
						add(Char);
						Deaths = Deaths + 1;
						remove(DeathCounter);
						DeathCounter = new GLabel("Deaths: " + Deaths);
						if(Deaths < 100){
							DeathCounter.setLocation(blockSize * StageWidth - 64,11);
						}else{
							DeathCounter.setLocation(blockSize * StageWidth - 80,11);
						}
						add(DeathCounter);
						wdown = false;
						sdown = false;
						adown = false;
						ddown = false;
						wwdown = false;
						ssdown = false;
						aadown = false;
						dddown = false;
					}
				}
				for(int i = 0; i < Checks.size(); i++){
					GRect L = Checks.get(i);
					GImage T = CheckLights.get(i);
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						stx = Char.getX();
						sty = Char.getY();
						T.setImage("Tiles/" + blockSize + "/4_1.png");
					}else{
						if(L.getX() != stx && L.getY() != sty){
							T.setImage("Tiles/" + blockSize + "/4_0.png");
						}
					}
				}
				for(int i = 0; i < Checkstops.size(); i++){
					GRect L = Checkstops.get(i);
					GImage T = StopLights.get(i);
					if(L.getX() == Char.getX() && L.getY() == Char.getY()){
						stx = Char.getX();
						sty = Char.getY();
						T.setImage("Tiles/" + blockSize + "/5_1.png");
					}else{
						if(L.getX() != stx && L.getY() != sty){
							T.setImage("Tiles/" + blockSize + "/5_0.png");
						}
					}
				}
				if(Char.getX() == exx && Char.getY() == exy){
					level = level + 1;
					Walls = new ArrayList<GRect>();
					Blocks = new ArrayList<GRect>();
					Lines = new ArrayList<String>();
					Spikes = new ArrayList<GRect>();
					Stops = new ArrayList<GRect>();
					Ups = new ArrayList<GRect>();
					Downs = new ArrayList<GRect>();
					Lefts = new ArrayList<GRect>();
					Rights = new ArrayList<GRect>();
					Checks = new ArrayList<GRect>();
					CheckLights = new ArrayList<GImage>();
					Checkstops = new ArrayList<GRect>();
					StopLights = new ArrayList<GImage>();
					Occilators = new ArrayList<GImage>();
					System.out.println(level);
					fw = new FileReader("Levels/Level_" + level + ".txt");
					pw = new BufferedReader(fw);
					LevelName = pw.readLine();
					blockSize = Integer.parseInt(pw.readLine());
					StageWidth = Integer.parseInt(pw.readLine());
					StageHeight = Integer.parseInt(pw.readLine());
					for(int Y = 0;Y < StageHeight;Y++){
						lineOfLevel = pw.readLine();
						Lines.add(lineOfLevel);
						System.out.println(lineOfLevel);
					}
					for(int Y = 0;Y < StageHeight;Y++){
						for(int X = 0;X < StageWidth;X++){
							GRect block = new GRect(X * blockSize,Y * blockSize,blockSize,blockSize);
							GImage Over = new GImage("Tiles/8/0.png",X * blockSize,Y * blockSize);
							blockValueItTo = Lines.get(Y).charAt(X);
							if(blockValueItTo == '0'){
								block.setColor(Color.white);
								block.setFilled(true);
								add(block);
								if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
									Over.setImage("Tiles/" + blockSize + "/0.png");
									add(Over);
								}
							}else{
								if(blockValueItTo == '1'){
									block.setColor(Color.black);
									Walls.add(block);
									block.setFilled(true);
									add(block);
									texcon = 0;
									if(Y == 0){
										texcon = 8;
									}else{
										if(Lines.get(Y - 1).charAt(X) == '1'){
											texcon = 8;
										}
									}
									if(X == 0){
										texcon = texcon + 4;
									}else{
										if(Lines.get(Y).charAt(X - 1) == '1'){
											texcon = texcon + 4;
										}
									}
									if(Y == StageHeight - 1){
										texcon = texcon + 2;
									}else{
										if(Lines.get(Y + 1).charAt(X) == '1'){
											texcon = texcon + 2;
										}
									}
									if(X == StageWidth - 1){
										texcon = texcon + 1;
									}else{
										if(Lines.get(Y).charAt(X + 1) == '1'){
											texcon = texcon + 1;
										}
									}
									if(texcon == 15){
										if(Y != 0){
											if(X != StageWidth - 1){
												if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
													texcon = 16;
												}
											}
										}
										if(Y != StageHeight - 1){
											if(X != StageWidth - 1){
												if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
													texcon = 17;
													if(Y != 0){
														if(X != StageWidth - 1){
															if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
																texcon = 21;
															}
														}
													}
												}
											}
										}
										if(Y != StageHeight - 1){
											if(X != 0){
												if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
													texcon = 18;
													if(Y != 0){
														if(X != StageWidth - 1){
															if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
																texcon = 24;
															}
														}
													}
													if(Y != StageHeight - 1){
														if(X != StageWidth - 1){
															if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
																texcon = 22;
																if(Y != 0){
																	if(X != StageWidth - 1){
																		if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
																			texcon = 27;
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
										if(Y != 0){
											if(X != 0){
												if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
													texcon = 19;
													if(Y != StageHeight - 1){
														if(X != 0){
															if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
																texcon = 23;
															}
														}
													}
													if(Y != StageHeight - 1){
														if(X != StageWidth - 1){
															if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
																texcon = 25;
																if(Y != StageHeight - 1){
																	if(X != 0){
																		if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
																			texcon = 28;
																		}
																	}
																}
															}
														}
													}
													if(Y != 0){
														if(X != StageWidth - 1){
															if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
																texcon = 20;
																if(Y != StageHeight - 1){
																	if(Y != StageHeight - 1){
																		if(X != 0){
																			if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
																				texcon = 29;
																			}
																		}
																	}
																	if(X != StageWidth - 1){
																		if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
																			texcon = 26;
																			if(Y != StageHeight - 1){
																				if(X != 0){
																					if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
																						texcon = 30;
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
									if(texcon == 14){
										if(Y != 0){
											if(X != 0){
												if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
													texcon = 34;
												}
											}
										}
										if(Y != StageHeight - 1){
											if(X != 0){
												if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
													texcon = 38;
													if(Y != 0){
														if(X != 0){
															if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
																texcon = 42;
															}
														}
													}
												}
											}
										}
									}
									if(texcon == 13){
										if(Y != 0){
											if(X != StageWidth - 1){
												if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
													texcon = 31;
												}
											}
										}
										if(Y != 0){
											if(X != 0){
												if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
													texcon = 35;
													if(Y != 0){
														if(X != StageWidth - 1){
															if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
																texcon = 39;
															}
														}
													}
												}
											}
										}
									}
									if(texcon == 13){
										if(Y != 0){
											if(X != StageWidth - 1){
												if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
													texcon = 31;
												}
											}
										}
										if(Y != 0){
											if(X != 0){
												if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
													texcon = 35;
													if(Y != 0){
														if(X != StageWidth - 1){
															if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
																texcon = 39;
															}
														}
													}
												}
											}
										}
									}
									if(texcon == 11){
										if(Y != StageHeight - 1){
											if(X != StageWidth - 1){
												if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
													texcon = 32;
												}
											}
										}
										if(Y != 0){
											if(X != StageWidth - 1){
												if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
													texcon = 36;
													if(Y != StageHeight - 1){
														if(X != StageWidth - 1){
															if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
																texcon = 40;
															}
														}
													}
												}
											}
										}
									}
									if(texcon == 7){
										if(Y != StageHeight - 1){
											if(X != 0){
												if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
													texcon = 33;
												}
											}
										}
										if(Y != StageHeight - 1){
											if(X != StageWidth - 1){
												if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
													texcon = 37;
													if(Y != StageHeight - 1){
														if(X != 0){
															if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
																texcon = 41;
															}
														}
													}
												}
											}
										}
									}
									if(texcon == 3){
										if(Y != StageHeight - 1){
											if(X != StageWidth - 1){
												if(Lines.get(Y + 1).charAt(X + 1)!= '1' ){
													texcon = 43;
												}
											}
										}
									}
									if(texcon == 6){
										if(Y != StageHeight - 1){
											if(X != 0){
												if(Lines.get(Y + 1).charAt(X - 1)!= '1' ){
													texcon = 44;
												}
											}
										}
									}
									if(texcon == 12){
										if(Y != 0){
											if(X != 0){
												if(Lines.get(Y - 1).charAt(X - 1)!= '1' ){
													texcon = 45;
												}
											}
										}
									}
									if(texcon == 9){
										if(Y != 0){
											if(X != StageWidth - 1){
												if(Lines.get(Y - 1).charAt(X + 1)!= '1' ){
													texcon = 46;
												}
											}
										}
									}
									if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
										Over.setImage("Tiles/" + blockSize + "/1_" + texcon + ".png");
										add(Over);
									}
								}else{
									if(blockValueItTo == '2'){
										block.setColor(Color.blue);
										stx = X * blockSize;
										sty = Y * blockSize;
										block.setFilled(true);
										add(block);
										if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
											Over.setImage("Tiles/" + blockSize + "/2_0.png");
											add(Over);
										}
									}else{
										if(blockValueItTo == 'a'){
											Spikes.add(block);
											block.setColor(Color.yellow);
											block.setFilled(true);
											add(block);
											texcon = 0;
											if(Y == 0){
												texcon = 8;
											}else{
												if(Lines.get(Y - 1).charAt(X) == 'a'){
													texcon = 8;
												}
											}
											if(X == 0){
												texcon = texcon + 4;
											}else{
												if(Lines.get(Y).charAt(X - 1) == 'a'){
													texcon = texcon + 4;
												}
											}
											if(Y == StageHeight - 1){
												texcon = texcon + 2;
											}else{
												if(Lines.get(Y + 1).charAt(X) == 'a'){
													texcon = texcon + 2;
												}
											}
											if(X == StageWidth - 1){
												texcon = texcon + 1;
											}else{
												if(Lines.get(Y).charAt(X + 1) == 'a'){
													texcon = texcon + 1;
												}
											}
											if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
												Over.setImage("Tiles/" + blockSize + "/a_" + texcon + ".png");
												add(Over);
											}
										}else{
											if(blockValueItTo == 'b'){
												Stops.add(block);
												block.setColor(Color.gray);
												block.setFilled(true);
												add(block);
												texcon = 0;
												if(Y == 0){
													texcon = 8;
												}else{
													if(Lines.get(Y - 1).charAt(X) == 'b' || Lines.get(Y - 1).charAt(X) == '5'){
														texcon = 8;
													}
												}
												if(X == 0){
													texcon = texcon + 4;
												}else{
													if(Lines.get(Y).charAt(X - 1) == 'b' || Lines.get(Y).charAt(X - 1) == '5'){
														texcon = texcon + 4;
													}
												}
												if(Y == StageHeight - 1){
													texcon = texcon + 2;
												}else{
													if(Lines.get(Y + 1).charAt(X) == 'b' || Lines.get(Y + 1).charAt(X) == '5'){
														texcon = texcon + 2;
													}
												}
												if(X == StageWidth - 1){
													texcon = texcon + 1;
												}else{
													if(Lines.get(Y).charAt(X + 1) == 'b' || Lines.get(Y).charAt(X + 1) == '5'){
														texcon = texcon + 1;
													}
												}
												if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
													Over.setImage("Tiles/" + blockSize + "/b_" + texcon + ".png");
													add(Over);
												}
											}else{
												if(blockValueItTo == '3'){
													block.setColor(Color.red);
													exx = X * blockSize;
													exy = Y * blockSize;
													block.setFilled(true);
													add(block);
													if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
														Over.setImage("Tiles/" + blockSize + "/3_0.png");
														add(Over);
													}
												}else{
													if(blockValueItTo == 'c'){
														block.setColor(Color.cyan);
														Ups.add(block);
														block.setFilled(true);
														add(block);
														if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
															Over.setImage("Tiles/" + blockSize + "/c.png");
															add(Over);
														}
													}else{
														if(blockValueItTo == 'd'){
															block.setColor(Color.pink);
															Downs.add(block);
															block.setFilled(true);
															add(block);
															if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																Over.setImage("Tiles/" + blockSize + "/d.png");
																add(Over);
															}
														}else{
															if(blockValueItTo == 'e'){
																block.setColor(Color.orange);
																Rights.add(block);
																block.setFilled(true);
																add(block);
																if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																	Over.setImage("Tiles/" + blockSize + "/e.png");
																	add(Over);
																}
															}else{
																if(blockValueItTo == 'f'){
																	block.setColor(Color.magenta);
																	Lefts.add(block);
																	block.setFilled(true);
																	add(block);
																	if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																		Over.setImage("Tiles/" + blockSize + "/f.png");
																		add(Over);
																	}
																}else{
																	if(blockValueItTo == '4'){
																		block.setColor(Color.green);
																		Checks.add(block);
																		block.setFilled(true);
																		add(block);
																		if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																			Over.setImage("Tiles/" + blockSize + "/4_0.png");
																			add(Over);
																			CheckLights.add(Over);
																		}
																	}else{
																		if(blockValueItTo == '5'){
																			block.setColor(Color.green);
																			Checkstops.add(block);
																			block.setFilled(true);
																			add(block);
																			Stops.add(block);
																			block.setColor(Color.gray);
																			block.setFilled(true);
																			add(block);
																			texcon = 0;
																			if(Y == 0){
																				texcon = 8;
																			}else{
																				if(Lines.get(Y - 1).charAt(X) == 'b' || Lines.get(Y - 1).charAt(X) == '5'){
																					texcon = 8;
																				}
																			}
																			if(X == 0){
																				texcon = texcon + 4;
																			}else{
																				if(Lines.get(Y).charAt(X - 1) == 'b' || Lines.get(Y).charAt(X - 1) == '5'){
																					texcon = texcon + 4;
																				}
																			}
																			if(Y == StageHeight - 1){
																				texcon = texcon + 2;
																			}else{
																				if(Lines.get(Y + 1).charAt(X) == 'b' || Lines.get(Y + 1).charAt(X) == '5'){
																					texcon = texcon + 2;
																				}
																			}
																			if(X == StageWidth - 1){
																				texcon = texcon + 1;
																			}else{
																				if(Lines.get(Y).charAt(X + 1) == 'b' || Lines.get(Y).charAt(X + 1) == '5'){
																					texcon = texcon + 1;
																				}
																			}
																			if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																				Over.setImage("Tiles/" + blockSize + "/b_" + texcon + ".png");
																				add(Over);
																			}
																			Over = new GImage("Tiles/8/0.png",X * blockSize,Y * blockSize);
																			if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																				Over.setImage("Tiles/" + blockSize + "/5_0.png");
																				add(Over);
																				StopLights.add(Over);
																			}
																		}else{
																			block.setColor(Color.green);
																			block.setFilled(true);
																			add(block);
																			if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
																				Over.setImage("Tiles/" + blockSize + "/e.png");
																				add(Over);
																				Occilators.add(Over);
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
							Blocks.add(block);
							pw.close();
							setSize(blockSize * StageWidth + 17,blockSize * StageHeight + 59);
							remove(Char);
							Char = new GImage("Tiles/20/Kitty.png",stx,sty);
							if(blockSize == 8 || blockSize == 16 || blockSize == 20 || blockSize == 32){
								Char.setImage("Tiles/" + blockSize + "/Kitty.png");
							}
							add(Char);
							LevelLabel = new GLabel("Level: " + level + " " + LevelName);
							LevelLabel.setLocation(0,11);
							add(LevelLabel);
							remove(DeathCounter);
							DeathCounter = new GLabel("Deaths: " + Deaths);
							if(Deaths < 100){
								DeathCounter.setLocation(blockSize * StageWidth - 64,11);
							}else{
								DeathCounter.setLocation(blockSize * StageWidth - 80,11);
							}
							add(DeathCounter);
							wdown = false;
							sdown = false;
							adown = false;
							ddown = false;
							wwdown = false;
							ssdown = false;
							aadown = false;
							dddown = false;
						}
					}
				}
			}
		}catch (IOException e){
			GLabel Error = new GLabel("Fatal Error: Level design not found. :'(");
			Error.setLocation(0,12);
			add(Error);
			while(true){
				Error.setColor(Color.red);
				pause(100);
				Error.setColor(Color.orange);
				pause(100);
				Error.setColor(Color.yellow);
				pause(100);
				Error.setColor(Color.green);
				pause(100);
				Error.setColor(Color.blue);
				pause(100);
				Error.setColor(Color.magenta);
				pause(100);
			}
		}
	}
	public void keyPressed(KeyEvent me){
		if(me.getKeyChar()=='w' || me.getKeyCode() == KeyEvent.VK_UP){
			wdown = true;
			wwdown = true;
		}
		if(me.getKeyChar()=='s' || me.getKeyCode() == KeyEvent.VK_DOWN){
			sdown = true;
			ssdown = true;
		}
		if(me.getKeyChar()=='a' || me.getKeyCode() == KeyEvent.VK_LEFT){
			adown = true;
			aadown = true;
		}
		if(me.getKeyChar()=='d' || me.getKeyCode() == KeyEvent.VK_RIGHT){
			ddown = true;
			dddown = true;
		}
	}
	public void mousePressed(MouseEvent e){
		if(mousex > 123 && mousex < 149 && mousey > 183 && mousey < 214){
			easyPressed = true;
		}else{
			easyPressed = false;
		}
		if(mousex > 149 && mousex < 186 && mousey > 185 && mousey < 212){
			normalPressed = true;
		}else{
			normalPressed = false;
		}
		if(mousex > 186 && mousex < 212 && mousey > 183 && mousey < 210){
			hardPressed = true;
		}else{
			hardPressed = false;
		}
		if(mousex > 288 && mousex < 415 && mousey > 192 && mousey < 223){
			titlePressed = true;
		}else{
			titlePressed = false;
		}
	}
	public void mouseMoved(MouseEvent me){
		mousex = me.getX();
		mousey = me.getY();
	}
}
